var VPPSClass = function() {}

VPPSClass.prototype.showMenu = function(menu) {
	var children = menu.childNodes;
	for (var x = children.length-1; x >= 0; x--) {
		menu.removeChild(children[x]);
	}
	var doc;
	showsourcemenu = document.createElement('menuitem');
	if (!gContextMenu || !gContextMenu.inFrame) {
		showsourcemenu.setAttribute("label", "View formatted source");
		doc = window.content;
	}
	else {
		showsourcemenu.setAttribute("label", "View formatted frameset source");			
		//doc=document.commandDispatcher.focusedWindow.content;	
		doc=document.commandDispatcher.focusedWindow;
		maindoc=window.content;
	}
	
	if (gContextMenu && gContextMenu.inFrame) {
		if (!doc.document.getElementById('__vpps_0')) {
			inlinemode = document.createElement('menuitem');
		  inlinemode.setAttribute("label", "Enable inline mode on frame");
		  inlinemode.setAttribute("oncommand", "VPPSObject.doInlineMode('frame');");
		  menu.appendChild(inlinemode);	  	  
		} else {
			inlinemoder = document.createElement('menuitem');
		  inlinemoder.setAttribute("label", "Disable inline mode on frame");
		  inlinemoder.setAttribute("oncommand", "VPPSObject.removeInlineMode('frame');");
		  menu.appendChild(inlinemoder);	  	  
		}
		if (!maindoc.document.getElementById('__vpps_0')) {
		  inlinemodef = document.createElement('menuitem');
		  inlinemodef.setAttribute("label", "Enable inline mode on frameset");
		  inlinemodef.setAttribute("oncommand", "VPPSObject.doInlineMode('maindoc');");
		  menu.appendChild(inlinemodef);	  	  
		} else {			
			inlinemodefr = document.createElement('menuitem');
		  inlinemodefr.setAttribute("label", "Disable inline mode on frameset");
		  inlinemodefr.setAttribute("oncommand", "VPPSObject.removeInlineMode('maindoc');");
		  menu.appendChild(inlinemodefr);	  	  
		}
	} else
	if (!gContextMenu || !gContextMenu.inFrame) {
		if (!doc.document.getElementById('__vpps_0')) {
			inlinemode = document.createElement('menuitem');
		  inlinemode.setAttribute("label", "Enable inline mode");
		  inlinemode.setAttribute("oncommand", "VPPSObject.doInlineMode('maindoc');");
		  menu.appendChild(inlinemode);		
		} else {
			inlinemoderem = document.createElement('menuitem');
		  inlinemoderem.setAttribute("label", "Disable inline mode");
		  inlinemoderem.setAttribute("oncommand", "VPPSObject.removeInlineMode('maindoc');");
		  menu.appendChild(inlinemoderem);		
		}
	}
	
	showsourcemenu.setAttribute("oncommand", "VPPSObject.doPrettyPrint('maindoc');");
	menu.appendChild(showsourcemenu);
	if (gContextMenu && gContextMenu.inFrame) {
		showsourcemenu = document.createElement('menuitem');
	  showsourcemenu.setAttribute("label", "View formatted frame source");
	  showsourcemenu.setAttribute("oncommand", "VPPSObject.doPrettyPrint('frame');");
	  menu.appendChild(showsourcemenu);	  
	}
	if (gContextMenu && gContextMenu.isTextSelected==true) {
		showselectedsourcemenu = document.createElement('menuitem');
	  showselectedsourcemenu.setAttribute("label", "View formatted selection");
	  showselectedsourcemenu.setAttribute("oncommand", "VPPSObject.doPrettyPrint('selection');");
	  menu.appendChild(showselectedsourcemenu);	  
	}
}

VPPSClass.prototype.renderFoldIcon = function(id) {
	fi="<div id=\"small"+id+"\" class=\"hilite\" style=\"display:none\"><a style=\"text-decoration:none\" href=\"javascript:fold('"+id+"')\">[+]</a>";
	for (ic=0;ic<indent;ic++) fi+="&nbsp;&nbsp;";
	fi+="&lt;"+currenttag.toLowerCase()+"&gt; ... &lt;/"+currenttag.toLowerCase()+"&gt;"+
	"&nbsp;<input type=text style='width:200px;border-style:solid;border-width:1px;font-size:10px;'></div><div id=\""+id+"\" class=\"lolite\"><span id=\"fold"+id+" style=\";position:relative;left:0px;\"><a style=\"text-decoration:none\" onmouseover=\"hilite('"+id+"')\" onmouseout=\"lolite('"+id+"')\" href=\"javascript:unfold('"+id+"')\">[-]</a></span>";
	return fi;
}

VPPSClass.prototype.isBlockElement = function(node) {
	return (node.tagName=="HEAD" || node.tagName=="UL" || node.tagName=="OL" || node.tagName=="DL" || node.tagName=="MAP" || node.tagName=="P" || node.tagName=="FONT" || node.tagName=="NOSCRIPT" || node.tagName=="BODY" || node.tagName=="TABLE" || node.tagName=="TR" || node.tagName=="TD" || node.tagName=="TH" || node.tagName=="DIV" || node.tagName=="SPAN" || node.tagName=="SCRIPT" || node.tagName=="FORM" || node.tagName=="SELECT");
}

VPPSClass.prototype.printNode = function(node) {
		var ic;	
		if (wrapdone==false) newhtml += "\n";	
		wrapdone=true;
		currenttag = node.tagName;
		link="";
		endlink="";
		if (this.isBlockElement(node)) {
			newhtml +=this.renderFoldIcon(node.tagName+tablenr);
			link="<a style=\"text-decoration:none\" onmouseover=\"hilite('"+node.tagName+tablenr+"')\" onmouseout=\"lolite('"+node.tagName+tablenr+"')\" href=\"javascript:void()\">";
			endlink="</a>";
			node.setAttribute('_vpps_id',tablenr);
			tablenr++;
		} else newhtml += "<span width=\"30\" style=\"width:30px;\">&nbsp;&nbsp;&nbsp;</span>";
		for (ic=0;ic<indent;ic++) newhtml+="&nbsp;&nbsp;";
		if (node.tagName=='IMG') {
			code = "<img ";
			var attributes = node.attributes;
			for (nc=0;nc<attributes.length;nc++) {
				value=attributes[nc].value;
				name=attributes[nc].name;
				if (name.toLowerCase()=='src') {					
					if (value.indexOf('://')==-1) {
						if (value.charAt(0) != '/') slash=pathname; else slash="";
						value=hostname+slash+value;
					}
				}
				code+=name + '=&quot;' + value + '&quot; ';
			}
			code += ">";
			
			link="<a style=\"text-decoration:none\" onmouseover=\"showimg('"+code+"');\" onmouseout=\"hideimg();\" href=\"javascript:void();\">";
			
			endlink="</a>";
		}
	  newhtml += "<font color=\"blue\">&lt;"+link+node.tagName.toLowerCase()+endlink;		
		var attributes = node.attributes;
		for (nc=0;nc<attributes.length;nc++) {
			if (attributes[nc].name != '_vpps_id')
				newhtml+=" <font color=red>"+attributes[nc].name+"="+"</font><font color=black>\""+attributes[nc].value+"\"</font>";
		}
		newhtml +="&gt;</font>&nbsp;&nbsp;<input type=\"text\" style='width:200px;border-style:none;border-width:0px;font-size:11px;font-style:italic;font-color:888888;background:none'>";	
		wrapdone=false;	
	}
	
VPPSClass.prototype.hasEndTag = function(node) {
	return !(node.tagName=="IMG" || node.tagName=="INPUT" || node.tagName=="BR");
}
	
VPPSClass.prototype.printFinalNode = function(node) {
		if (!this.hasEndTag(node)) return;
		var ic;
		if (wrapdone==false) newhtml+="\n";
		var link="";
		var endlink="";
		if (this.isBlockElement(node)) {
			nr = node.getAttribute('_vpps_id');
			link="<a style=\"text-decoration:none\" onmouseover=\"hilite('"+node.tagName+nr+"')\" onmouseout=\"lolite('"+node.tagName+nr+"')\" href=\"javascript:void()\">";
			endlink="</a>";
		}
		newhtml+="<span width=\"30\" style=\"\">&nbsp;&nbsp;&nbsp;</span>";
		for (ic=0;ic<indent;ic++) newhtml+="&nbsp;&nbsp;";
		newhtml += "<font color=blue>&lt;/"+link+node.tagName.toLowerCase()+endlink+"&gt;</font>&nbsp;&nbsp;<input type=\"text\" style='width:200px;border-style:none;border-width:0px;font-size:11px;font-style:italic;font-color:888888;background:none'>";
		if (this.isBlockElement(node)) {
			 newhtml+="</div>";
			 wrapdone=true;
			} else wrapdone=false;
		currenttag="";		
	}
	VPPSClass.prototype.trimText = function(text) {
		//return text;
		var beginning=-1;
		for (c=0;c<text.length;c++) {
			var ch = text.charCodeAt(c);			
			if (ch>32) {
				beginning=c;
				break;
			}
		}
		var ending=-1;
		for (c=text.length;c>0;c--) {
			var ch = text.charCodeAt(c);			
			if (ch>32) {
				ending=c;				
				break;
			}
		}		
	if (ending==-1 || beginning==-1) return ""; else return text.substring(beginning, ending+1);
	}
	
	VPPSClass.prototype.printComment = function(text) {		
		text = text.split('&');
		text = text.join('&amp;');		
		text = text.split("<");
		text = text.join("&lt;");
		text = text.split(">");
		text = text.join("&gt;");	
		text = text.split("\"");
		text = text.join("&quot;");

		var space="<table border=0 align=left><tr><td><span style=\"width:30px;\">&nbsp;&nbsp;</span>";
		for (ic=0;ic<indent;ic++) space+="&nbsp;&nbsp;";
		space+="</td></tr></table>";
		return space+"<table border=0 width=500><tr><td><font color=darkgrey><i>&lt;!--"+text+"--&gt;</i></font></td></tr></table>";
		wrapdone=true;
	}
	
	const specialchar = new Array("&","<",">","\"","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","");
	const replacements = new Array("amp;","lt;","gt;","quot;","OElig;","oelig;","Scaron;","scaron;","Yuml;","circ;","tilde;","ndash;","mdash;","lsquo;","rsquo;","sbquo","ldquo;","rdquo;","bdquo;","dagger;","Dagger;","permil;","lsaquo;","rsaquo;","euro;","auml;","Auml;","ouml;","Ouml;","uuml;","Uuml;","nbsp;","cent;","&curren","brvbar;","uml;","para;","Agrave;","Acirc;","AElig;","Egrave;","Ecirc;","Igrave;","Icirc;","Ograve;","Ocirc;","Oslash;","Uacute;","agrave","acirc;","aelig;","egrave;","ecirc;","igrave;","icirc;","eth;","ograve;","ocirc;","oslash;","uacute;","thorn;","pound;","yen;","sect;","copy;","laquo;","macr;","plusmn;","sup3;","micro;","middot;","sup1;","raquo;","frac12;","iquest;","Aacute;","Atilde;","Aring;","Ccedil;","Eacute;","Euml;","Iacute;","Iuml;","Ntilde;","Oacute;","Otilde;","times;","Ugrave;","Ucirc;","Yacute;","szlig;","aacute;","atilde;","aring;","ccedil;","eacute;","euml;","iacute;","iuml;","ntilde;","oacute;","otilde;","divide;","ugrave;","ucirc;","yacute;","yuml;");
	
	VPPSClass.prototype.printSimpletext = function(text) {
		var istext=false;
		var whitespace = String.fromCharCode(32);
		var newline = String.fromCharCode(10);
		var endofline = String.fromCharCode(13);
		var ic;		
		text=this.trimText(text);
		if (text.length==0) return;		
		//for (ic=0;ic<indent;ic++) newhtml+="&nbsp;&nbsp;";
		if (currenttag != "SCRIPT") {
			text = text.split("\n");			
			text = text.join("");
			text = text.split("\r");
		  text = text.join("");			
		  
		}
		for (var c=0;c<specialchar.length;c++) {
			text = text.split(specialchar[c]);
			text = text.join("&amp;"+replacements[c]);
		}

		var space="<table border=0 align=left><tr><td><span style=\"width:30px;\"></span>";
		for (ic=0;ic<indent;ic++) space+="&nbsp;&nbsp;";
		space+="</td></tr></table>";
		newhtml += space+"<table border=0 width=500><tr><td>"+text+"</td></tr></table>";
		wrapdone=true;
		//newhtml+="<span width=500><table border=1 align="left" width=500><tr><td>"+text+"</td></tr></table></span>";
	}
	VPPSClass.prototype.printChildren = function(node) {		
		var x;
		for (x=0;x<node.childNodes.length;x++) {			
			if (node.childNodes[x].nodeType == 3) {
				++indent;
				this.printSimpletext(node.childNodes[x].nodeValue);
				--indent;
			}
		  else
		  if (node.childNodes[x].nodeType == 8) {
		  	newhtml+=this.printComment(node.childNodes[x].nodeValue);  	
		  } else
		  if (node.childNodes[x].nodeType == 1) {
		  	var curnode = node.childNodes[x];
		  	if (curnode.id.indexOf('__vpps_')!=-1) curnode = curnode.firstChild.nextSibling;		
				this.printNode(curnode);
				if (curnode.childNodes.length>0) {
					++indent;
					//newhtml+="\n";
					this.printChildren(curnode);				
					--indent;
				}
				this.printFinalNode(curnode);				
			} else alert('Unknown node type '+node.childNodes[x].nodeType);
		}
		
	}
	
	VPPSClass.prototype.createJavascriptFunctions = function() {
		newhtml += "<script type=\"text/javascript\">\n"+
		"function hilite(id) {\n"+		
		"document.getElementById(id).className='hilite';\n"+
		"}\n"+
		"function lolite(id) {\n"+
		"document.getElementById(id).className=\"lolite\";\n"+
		"}\n"+
		"function unfold(id) {\n"+
		"document.getElementById(id).style.display='none';"+
		"document.getElementById('small'+id).style.display='';"+
		"}\n"+
		"function fold(id) {\n"+
		"document.getElementById(id).style.display='';"+
		"document.getElementById('small'+id).style.display='none';"+
		"}\n"+
		"function showimg(code) {\n"+
		"document.getElementById('previewimg').innerHTML='<table border=0 cellpadding=5><tr><td>'+code+'</td></tr></table>';\n"+
		"document.getElementById('previewimg').style.top=document.body.scrollTop+5;\n"+
		"document.getElementById('previewimg').style.left=document.body.scrollLeft+5;\n"+
		"document.getElementById('previewimg').style.display='';\n"+
		"}\n"+
		"function hideimg() {\n"+
		"document.getElementById('previewimg').style.display='none';\n"+
		"}\n"+		
		"</scr"+"ipt>\n";
	}
	
	VPPSClass.prototype.createCSS = function() {
		newhtml += "<STYLE type=\"text/css\">\n"+
   		".hilite {background-color:#eeeeee};\n"+
   		".lolite {background-color:#ffffff};\n"+
 			"</STYLE>";
	}
	
	VPPSClass.newhtml="";
	VPPSClass.indent=0;
	VPPSClass.currenttag="";	
	VPPSClass.tablenr=0;
	VPPSClass.wrapdone=false;
	VPPSClass.hostname="";
	VPPSClass.pathname="";
	VPPSClass.images = new Array();
	VPPSClass.imagenr = 0;
	
	VPPSClass.prototype.doPrettyPrint = function(what) {
		if (what=="maindoc") {
			 source = window.content.document.getElementsByTagName("html")[0];
			 hostname = window.content.location.protocol+"//"+window.content.location.hostname;
			 pathname = window.content.location.pathname;
			 if (pathname.charAt(pathname.length-1)!='/') {
			 	 if (pathname.lastIndexOf('/')!=-1) {
			 	 		pathname = pathname.substring(0,pathname.lastIndexOf('/')+1);
			 	 } else
			 	 	pathname+='/';
			 	}	 			
			}
		else
		if (what=="frame") {
			 source = document.commandDispatcher.focusedWindow.document.getElementsByTagName("html")[0];		
			 hostname = document.commandDispatcher.focusedWindow.content.location.protocol+"//"+document.commandDispatcher.focusedWindow.content.location.hostname;
			 pathname = document.commandDispatcher.focusedWindow.content.location.pathname;
			 if (pathname.charAt(pathname.length-1)!='/') {
				 if (pathname.lastIndexOf('/')!=-1) {
				 		pathname = pathname.substring(0,pathname.lastIndexOf('/')+1);
				 } else
				 	pathname+='/';
			 }	 
		}
		if (what=="selection") {
			//var focusedWindow = document.commandDispatcher.focusedWindow.content;
			//var focusedWindow = window.content;
    	//code = focusedWindow.__proto__.getSelection.call(focusedWindow);
			source = document.commandDispatcher.focusedWindow.document.getElementsByTagName("html")[0];		
			 hostname = document.commandDispatcher.focusedWindow.content.location.protocol+"//"+document.commandDispatcher.focusedWindow.content.location.hostname;
			 pathname = document.commandDispatcher.focusedWindow.content.location.pathname;
			 if (pathname.charAt(pathname.length-1)!='/') {
				 if (pathname.lastIndexOf('/')!=-1) {
				 		pathname = pathname.substring(0,pathname.lastIndexOf('/')+1);
				 } else
				 	pathname+='/';
			 }	     	
    	var code=document.commandDispatcher.focusedWindow.getSelection();    	    	
			sourcec = getSelectionHtml(code);			
			source=sourcec;
		}
		//var source=window._content.document.getElementsByTagName("html")[0];		
		this.createDocument(source);
	}
	
	VPPSClass.prototype.createDocument = function(source) {
		next = source;		
		newhtml="<html><head><title>Formatted source</title>";
		this.createJavascriptFunctions();		
		this.createCSS();
		newhtml+="</head><body><span id='previewimg' style='display:none;border:1px;border-style:solid;background-color:#eeeeee;position:absolute;top:5px;left:5px;'></span>";
		wrapdone=false;
		indent=0;
		currenttag="";
		tablenr=0;
		images = new Array();
	  imagenr = 0;
		this.printNode(source);
		indent++;
		this.printChildren(next);
		indent--;
		this.printFinalNode(source);
		newhtml+="</body></html>";
		// mark selection
		newhtml = newhtml.split("[[selstart]]");
		newhtml = newhtml.join("<span style=\"background-color:#ffff88\">");
		newhtml = newhtml.split("[[selend]]");
		newhtml = newhtml.join("</span>");
		try {
			var sourcewin = window.openDialog("chrome://vpps/content/window.xul", "Source", "chrome,dialog=0,resizable=1,left=30,top=30,width=800,height=600","<pre>"+newhtml+"</pre>");			
		} catch (E) {			
			var sourcewin = window.open("about:blank", "Source", "resizable=1,left=30,top=30,width=800,height=600");
			sourcewin.document.write("<pre>"+newhtml+"</pre>");
			sourcewin.document.close();
		}
	}
	
	VPPSClass.prototype.createFromInlineDocument = function(source,what) {
		if (what=="maindoc") {			 		
			 hostname = window.content.location.protocol+"//"+window.content.location.hostname;
			 pathname = window.content.location.pathname;
			 if (pathname.charAt(pathname.length-1)!='/') {
			 	 if (pathname.lastIndexOf('/')!=-1) {
			 	 		pathname = pathname.substring(0,pathname.lastIndexOf('/')+1);
			 	 } else
			 	 	pathname+='/';
			 	}	 
			}
		else
		if (what=="frame") {
			hostname = document.location.protocol+"//"+document.location.hostname;
			pathname = document.location.pathname;
			if (pathname.charAt(pathname.length-1)!='/') {
				 if (pathname.lastIndexOf('/')!=-1) {
				 		pathname = pathname.substring(0,pathname.lastIndexOf('/')+1);
				 } else
				 	pathname+='/';
			}	 
		}
			  this.createDocument(source);
	}
	
	VPPSClass.prototype.doInlineMode = function(what) {
		if (what=="frame")
			source = document.commandDispatcher.focusedWindow.document;		
		if (what=="maindoc")
			 source = window.content.document;					
		this.scanChildren(source,what);
	}	
	
	VPPSClass.prototype.removeInlineMode = function(what) {
		if (what=="frame")
			source = document.commandDispatcher.focusedWindow.document;		
		if (what=="maindoc")
			 source = window.content.document;					
		this.removeInlineModeDivs(source,what);
	}	
		
	const blockelements = new Array('DIV','TABLE','SPAN');
	const linestyles = new Array("solid red 2px","solid blue 2px","dotted red 2px","dotted blue 2px","solid #c0c0c0 2px","dotted #c0c0c0 2px");
	
	VPPSClass.prototype.scanChildren = function(source,on) {
		if (source.getElementById('__vpps_0')) return;
		var head = source.getElementsByTagName('HEAD');
		script = source.createElement('script');
		script.src="chrome://vpps/content/vpps.js";
		script.type="text/javascript";
		head[0].appendChild(script);
		var nr=0;
		var currentstyle=0;
		for (var x = 0; x<blockelements.length; x++) {
			var p = source.getElementsByTagName(blockelements[x]);
	   	for(var i=0; i<p.length; i++){
	    	var node = p[i];
	    	if (node.id.indexOf('__vpps_')!=-1) { continue};
	    	span = source.createElement('div');    	
	    	link = source.createElement('a');
	    	var id = '__vpps_'+nr;
	    	nr++;
	    	span.id=id;
	    	link.href="javascript:VPPSObject.createFromInlineDocument(document.getElementById('"+id+"').firstChild.nextSibling,'"+on+"');";
	    	img = source.createElement('img');
	    	img.src='chrome://vpps/skin/source.png';	    	
	    	img.border=0;
	    	link.appendChild(img);
	    	span.appendChild(link);
	    	span.style.border=linestyles[currentstyle];
	    	currentstyle++;
	    	if (currentstyle>=linestyles.length) currentstyle=0;
	      span.appendChild(node.cloneNode(true));
	      node.parentNode.replaceChild(span,node);      
	      if (node.tagName=='DIV') { i++;} // skip node
			}
		}
	}	
	
	VPPSClass.prototype.removeInlineModeDivs = function(source,on) {
		
		if (!source.getElementById('__vpps_0')) return;
		
		var nr=0;
		var currentstyle=0;		
		var removed=false;
		do {
			var p = source.getElementsByTagName("DIV");
			removed=false;			
		  for(var i=0; i<p.length; i++){
		   	var node = p[i];
		   	if (node.id.indexOf('__vpps_')==-1) { continue};	  	    	
		   	removed=true;
		    node.parentNode.replaceChild(node.firstChild.nextSibling,node);      	      
			}		
		} while (removed==true);
	}	
	
const VPPSObject = new VPPSClass();	

function onLoadViewFormattedSource() {
	window.content.document.write(window.arguments[0]);
	window.content.document.close();
}

function onUnloadViewFormattedSource()
{
  uninitFindBar();
  window.content.document.open();
  window.content.document.close();
}
	
	////////////////////////////////////////////////////////////////////////////////
// helper to get a path like FIXptr, but with an array instead of the "tumbler" notation
// see FIXptr: http://lists.w3.org/Archives/Public/www-xml-linking-comments/2001AprJun/att-0074/01-NOTE-FIXptr-20010425.htm
function getPath(ancestor, node)
{	
  var n = node;
  var p = n.parentNode;
  if (n == ancestor || !p)
    return null;
  var path = new Array();
  if (!path)
    return null;
  do {
    for (var i = 0; i < p.childNodes.length; i++) {
      if (p.childNodes.item(i) == n) {
        path.push(i);
        break;
      }
    }
    n = p;
    p = n.parentNode;
  } while (n != ancestor && p);
  return path;
}

	function getSelectionHtml(selection) {		
// code taken from viewPartialSource.js from toolkit.jar	
//const MARK_SELECTION_START = '\u200B\u200B\u200B\u200B\u200B';
//const MARK_SELECTION_END = '\u200B\u200B\u200B\u200B\u200B';
const MARK_SELECTION_START = '[[selstart]]';
const MARK_SELECTION_END = '[[selend]]';
const gViewSourceCSS = 'resource://gre/res/viewsource.css';
const NS_XHTML = 'http://www.w3.org/1999/xhtml';		
		  var range = selection.getRangeAt(0);		  
  var ancestorContainer = range.commonAncestorContainer;
  var doc = ancestorContainer.ownerDocument;

  var startContainer = range.startContainer;
  var endContainer = range.endContainer;
  var startOffset = range.startOffset;
  var endOffset = range.endOffset;

  // let the ancestor be an element
  if (ancestorContainer.nodeType == Node.TEXT_NODE ||
      ancestorContainer.nodeType == Node.CDATA_SECTION_NODE)
    ancestorContainer = ancestorContainer.parentNode;

  // for selectAll, let's use the entire document, including <html>...</html>
  // @see DocumentViewerImpl::SelectAll() for how selectAll is implemented
  try {
    if (ancestorContainer == doc.body)
      ancestorContainer = doc.documentElement;
  } catch (e) { }

  // each path is a "child sequence" (a.k.a. "tumbler") that
  // descends from the ancestor down to the boundary point
  var startPath = getPath(ancestorContainer, startContainer);
  var endPath = getPath(ancestorContainer, endContainer);

  // clone the fragment of interest and reset everything to be relative to it
  // note: it is with the clone that we operate from now on
  ancestorContainer = ancestorContainer.cloneNode(true);
  startContainer = ancestorContainer;
  endContainer = ancestorContainer;
  var i;
  for (i = startPath ? startPath.length-1 : -1; i >= 0; i--) {
    startContainer = startContainer.childNodes.item(startPath[i]);
  }
  for (i = endPath ? endPath.length-1 : -1; i >= 0; i--) {
    endContainer = endContainer.childNodes.item(endPath[i]);
  }

  // add special markers to record the extent of the selection
  // note: |startOffset| and |endOffset| are interpreted either as
  // offsets in the text data or as child indices (see the Range spec)
  // (here, munging the end point first to keep the start point safe...)
  var tmpNode;
  if (endContainer.nodeType == Node.TEXT_NODE ||
      endContainer.nodeType == Node.CDATA_SECTION_NODE) {
    // do some extra tweaks to try to avoid the view-source output to look like
    // ...<tag>]... or ...]</tag>... (where ']' marks the end of the selection).
    // To get a neat output, the idea here is to remap the end point from:
    // 1. ...<tag>]...   to   ...]<tag>...
    // 2. ...]</tag>...  to   ...</tag>]...
    if ((endOffset > 0 && endOffset < endContainer.data.length) ||
        !endContainer.parentNode || !endContainer.parentNode.parentNode)
      endContainer.insertData(endOffset, MARK_SELECTION_END);
    else {
      tmpNode = doc.createTextNode(MARK_SELECTION_END);
      endContainer = endContainer.parentNode;
      if (endOffset == 0)
        endContainer.parentNode.insertBefore(tmpNode, endContainer);
      else
        endContainer.parentNode.insertBefore(tmpNode, endContainer.nextSibling);
    }
  }
  else {
    tmpNode = doc.createTextNode(MARK_SELECTION_END);
    endContainer.insertBefore(tmpNode, endContainer.childNodes.item(endOffset));
  }

  if (startContainer.nodeType == Node.TEXT_NODE ||
      startContainer.nodeType == Node.CDATA_SECTION_NODE) {
    // do some extra tweaks to try to avoid the view-source output to look like
    // ...<tag>[... or ...[</tag>... (where '[' marks the start of the selection).
    // To get a neat output, the idea here is to remap the start point from:
    // 1. ...<tag>[...   to   ...[<tag>...
    // 2. ...[</tag>...  to   ...</tag>[...
    if ((startOffset > 0 && startOffset < startContainer.data.length) ||
        !startContainer.parentNode || !startContainer.parentNode.parentNode ||
        startContainer != startContainer.parentNode.lastChild)
      startContainer.insertData(startOffset, MARK_SELECTION_START);
    else {
      tmpNode = doc.createTextNode(MARK_SELECTION_START);
      startContainer = startContainer.parentNode;
      if (startOffset == 0)
        startContainer.parentNode.insertBefore(tmpNode, startContainer);
      else
        startContainer.parentNode.insertBefore(tmpNode, startContainer.nextSibling);
    }
  }
  else {
    tmpNode = doc.createTextNode(MARK_SELECTION_START);
    startContainer.insertBefore(tmpNode, startContainer.childNodes.item(startOffset));
  }

	return ancestorContainer;
	}
	// end code taken from viewPartialSource.js